		ret

;******************************************************
; 
;******************************************************    EEPROM
waitEEPE:
		sbic	EECR, EEPE        		;   FLASH
		rjmp	waitEEPE
		ret
;    D  FLASH c     OUZMinFP8(2)....OUZMaxFP8(166)
LoadTable:
		pusha
		andi	D,UOZCount-1
		ldi		B,32
		mul		B,D
		ldi		XL,Low(UOZ)
		ldi		XH,High(UOZ)
		add		XL,r0
		adc		XH,r1
LT_1:	rcall	waitEEPE                
		out		EEARH,r1
		out		EEARL,r0
		sub		r0,full					;inc r1:r0
		sbc		r1,full
		sbi		EECR,EERE
		in		D,EEDR
		ldi		A,OUZMinFP8		
		sub		A,D			
		brcs	LT_2
		ldi		D,OUZMinFP8
LT_2:	ldi		A,OUZMaxFP8			
		sub		A,D			
		brcc	LT_3
		ldi		D,OUZMaxFP8	
LT_3:	st		X+,D
		dec		B
		brne	LT_1
		popa
		ret

;    FLASH    UART   
LoadAllTableOverUART:
		push	B
		push	D
		ldi		B,UOZCount-1
LATU_1:	ldi		D,0xC0
		add		D,B
		rcall	AddUARTCommand
		subi	B,1
		brcc	LATU_1
		pop		D
		pop		B
		ret
;    FLASH 
LoadAllTable:
		push	D
		ldi		D,UOZCount-1
LAT_1:	rcall	LoadTable
		subi	D,1
		brcc	LAT_1
		pop		D
		ret
; ( )    D (       )
ResetTable:		
		pusha							
		andi	D,UOZCount-1
		inc		D
		ldi		XL,Low(UOZ)
		ldi		XH,High(UOZ)
		ldi		A,32
		mul		A,D
		add		XL,r0
		adc		XH,r1
		rcall	FillTable
		popa
		ret
;      (   FLASH)
ResetAllTables:
		push	D
		ldi		D,UOZCount-1
RAT_1:	rcall	ResetTable				
		subi	D,1
		brcc	RAT_1
		pop		D
		ret		
;     D(5)    FLASH
WriteTable:    
		pusha
		andi	D,UOZCount-1
		ldi		B,32
		mul		B,D
		ldi		XL,Low(UOZ)
		ldi		XH,High(UOZ)
		add		XL,r0
		adc		XH,r1
WT_1:	ld		D,X+
		rcall	waitEEPE
		out		EEARH,r1
		out		EEARL,r0
		sub		r0,full					;inc r1:r0
		sbc		r1,full
		sbi		EECR,EERE
		in		A,EEDR
		cp		A,D
		breq	WT_2					;  !!
		cli
		rcall	waitEEPE
		out		EEDR,D
		sbi		EECR,EEMPE
		sbi		EECR,EEPE
		rcall	waitEEPE
		sei
WT_2:	dec		B
		brne	WT_1
		popa
		ret

SaveAllTable:
		push	D
		ldi		D,UOZCount-1
SAT_1:	rcall	WriteTable
		subi	D,1
		brcc	SAT_1
		pop		D
		ret		

;******************************************************    UART
UARTInit:	
		clr		XH	
		ldi		XL,UBRR0L
		ldi		A,207	   				;16-115 207-9600
		st		X+,A
		st		X,zerro
; UCSR0A - USART Control and Status Register A
;.equ	MPCM0	= 0	; Multi-processor Communication Mode
;.equ 1	U2X0	= 1	; Double the USART transmission speed
;.equ	UPE0	= 2	; Parity Error
;.equ	DOR0	= 3	; Data overRun
;.equ	FE0	= 4	; Framing Error
;.equ	UDRE0	= 5	; USART Data Register Empty
;.equ	TXC0	= 6	; USART Transmitt Complete
;.equ	RXC0	= 7	; USART Receive Complete
		ldi		A,0b00000010
		ldi		XL,UCSR0A
		st		X+,A
; UCSR0B - USART Control and Status Register B
;.equ	TXB80	= 0	; Transmit Data Bit 8
;.equ	RXB80	= 1	; Receive Data Bit 8
;.equ	UCSZ02	= 2	; Character Size
;.equ 1	TXEN0	= 3	; Transmitter Enable
;.equ 1	RXEN0	= 4	; Receiver Enable
;.equ	UDRIE0	= 5	; USART Data register Empty Interrupt Enable
;.equ	TXCIE0	= 6	; TX Complete Interrupt Enable
;.equ 1	RXCIE0	= 7	; RX Complete Interrupt Enable
		ldi 	A,0b10011000
		st		X+,A
;.equ	UCPOL0	= 0	; Clock Polarity
;.equ 1	UCSZ00	= 1	; Character Size
;.equ 1	UCSZ01	= 2	; Character Size           UCSZ01=0 -> UCSR0B
;.equ	USBS0	= 3	; Stop Bit Select
;.equ	UPM00	= 4	; Parity Mode Bit 0
;.equ	UPM01	= 5	; Parity Mode Bit 1
;.equ	UMSEL00	= 6	; USART Mode Select			00 -  
;.equ	UMSEL01	= 7	; USART Mode Select			01 -  
		ldi 	A,0b00000110 
		st		X,A
		rcall	ResetUart
		ret

RX_OK:	pushSREG						;      UART  
		push	D
		clr		ZH
		ldi		ZL,UDR0
		ld		D,Z
		tst		D						;   0 -   UART 
		brne	RX_OK_1			
		rcall	ResetUart
		pop		D
		popSREG
		reti
RX_OK_1:rcall	AddUARTCommand
		pop		D
		popSREG
		reti
ResetUart:	
		sts		RptrI,zerro
		sts		RptrO,zerro
		sts		TptrI,zerro
		sts		TptrO,zerro
		clr		TableAdress
		cbr		EStatus,TnotEmpty+RnewCMD+RError+TError
		ret
CheckUARTflags:	
		push	A
		push	B
		cbr		EStatus,RnewCMD+TnotEmpty
		sbr		EStatus,RError+TError
		lds		A,RptrI
		lds		B,RptrO
		cpse	A,B	
		sbr		EStatus,RnewCMD
		inc		A
		cpse	A,B	
		cbr		EStatus,RError
		lds		A,TptrI     
		lds		B,TptrO     
		cpse	A,B			
		sbr		EStatus,TnotEmpty
		inc		A
		cpse	A,B	
		cbr		EStatus,TError
		pop		B
		pop		A
		ret	

AddUARTCommand:	
		rcall	CheckUARTflags
		sbrc	EStatus,RErrorBit		;   -   
		ret
		push	XH
		push	XL
		push	A
		IncPtrA	RptrI	
		ldi		XL,Low(RBuff)
		ldi		XH,High(RBuff)
		add		XL,A
		adc		XH,zerro
		pop		A
		st		X,D
		pop		XL
		pop		XH
		sbr		EStatus,RnewCMD			;   !
		ret

SendData:								;D -   
		push	YL
		push	YH
		push	A
		push	B
SD_1:	rcall	TransmiteData 
		rcall	CheckUARTflags
		sbrc	EStatus,TErrorBit		;   
		rjmp	SD_1
		ldi		YL,Low(TBuff)
		ldi		YH,High(TBuff)
		IncPtrA	TptrI
		add		YL,A
		adc		YH,zerro
		st		Y,D
		pop		B
		pop		A
		pop		YH
		pop		YL
		ret

TransmiteData:
		rcall	CheckUARTflags
		sbrs	EStatus,TnotEmptyBit	;     
		ret
		clr		YH			
		ldi		YL,UCSR0A				;    
		ld		B,Y	
		sbrs	B,UDRE0	
		ret								;    
		ldi		YL,Low(TBuff)
		ldi		YH,High(TBuff)
	    IncPtrA	TptrO
		add		YL,A
		adc		YH,zerro
		ld		B,Y
		clr		YH			
		ldi		YL,UDR0					; 
		st		Y,B
		ret

ReadCmd:rcall	CheckUARTflags
		sbrs	EStatus,RnewCMDBit		;   , 
		ret
		ldi		XL,Low(RBuff)
		ldi		XH,High(RBuff)
		IncPtrA RptrO       
		add		XL,A
		adc		XH,zerro
		ld		D,X
		rcall	ExecuteCmd
		ret

UARTMODE:
	    rcall	TransmiteData  //Y,B,A
		rcall	CheckUARTflags
		rcall	ReadCmd
		ret

ExecuteCmd:								;D -  
;E0+D(5)  ( )    D(5) (   FLASH)
		push	D						;D -  
		andi	D,0xE0					;   E0+
		cpi		D,0xE0
		pop		D			
		brne	CmdC0
		rcall	ResetTable		
		ret
;C0+D(5)      D(5)  FLASH  
CmdC0:	push	D						;D -  
		andi	D,0xE0					;   C0+
		cpi		D,0xC0
		pop		D			
		brne	CmdA0
		rcall	LoadTable
		ret
;A0+D(5)      D(5)   FLASH
CmdA0:	push	D						;D -  
		andi	D,0xE0					;   A0+
		cpi		D,0xA0
		pop		D			
		brne	Cmd80
		rcall	WriteTable
		ret
;80+D(5)    
Cmd80:	push	D						;D -  
		andi	D,0xE0					;   80+
		cpi		D,0x80
		pop		D			
		brne	Cmd60
		andi	D,UOZCount-1
		mov		UOZSelectr,D
		sbr		Status,UARTCtrl
		ret
;60+D(5)      D(5)
Cmd60:	push	D						;D -  
		andi	D,0xE0					;   80+
		cpi		D,0x60
		pop		D			
		brne	Cmd40
		rcall	SendData
		andi	D,UOZCount-1
		ldi		A,32
		mul		D,A						;r1:r0 -  
		mov		D,A
		rcall	SendData
		ldi		XL,low(UOZ)				
		ldi		XH,High(UOZ)
		add		XL,r0
		adc		XH,r1
Cmd60_1:ld		D,X+
		rcall	SendData
		ldi		D,1
		add		r0,D
		adc		r1,D
		dec		A
		brne	Cmd60_1
		ret
;40+A(5)       
Cmd40:	push	D						;D -  
		andi	D,0xE0					;   80+
		cpi		D,0x40
		pop		D			
		brne	Cmd30
		andi	D,0x1F
		mov		TableAdress,D			
		ret
;30+D(4)          
Cmd30:	push	D						;D -  
		andi	D,0xF0					;   80+
		cpi		D,0x30
		pop		D			
		brne	Cmd20
		ldi		XL,low(UOZ)				
		ldi		XH,High(UOZ)
		mov		A,UOZSelectr
		andi	A,UOZCount-1
		ldi		B,32
		mul		B,A
		add		XL,r0					
		adc		XH,r1
		add		XL,TableAdress
		adc		XH,zerro
		andi	D,0x0F
		swap	D
		ld		A,X
		andi	A,0x0F
		add		A,D
   		st		X,A
		ret
;20+D(4)          
Cmd20:	push	D						;D -  
		andi	D,0xF0					;   80+
		cpi		D,0x20
		pop		D			
		brne	Cmd10
		ldi		XL,low(UOZ)				
		ldi		XH,High(UOZ)
		mov		A,UOZSelectr
		andi	A,UOZCount-1
		ldi		B,32
		mul		B,A
		add		XL,r0					
		adc		XH,r1
		add		XL,TableAdress
		adc		XH,zerro
		ld		A,X
		andi	A,0xF0
		andi	D,0x0F
		add		A,D
   		st		X,A
		ret
;10+D(4) 
Cmd10:	push	D						;D -  
		andi	D,0xF0					;   80+
		cpi		D,0x10
		pop		D			
		brne	CmdF
		ret
;F    ( )    OUZMinFP8, OUZMaxFP8, LDelta, 
;Base(HL), Fn, Ka, UOZCount, LDeltaFP16(HL)
CmdF:	cpi		D,0x0F
		brne	CmdE
		rcall	SendData
		ldi		D,11
		rcall	SendData
		ldi		D,Version						
		rcall	SendData
		ldi		D,OUZMinFP8
		rcall	SendData
		ldi		D,OUZMaxFP8
		rcall	SendData
		ldi		D,LDelta
		rcall	SendData
		ldi		D,High(Base)
		rcall	SendData
		ldi		D,Low(Base)
		rcall	SendData
		ldi		D,Fn
		rcall	SendData
		ldi		D,Ka
		rcall	SendData
		ldi		D,UOZCount
		rcall	SendData
		ldi		D,High(LDeltaFP16)
		rcall	SendData
		ldi		D,Low(LDeltaFP16)
		rcall	SendData
		ret
;E       (   FLASH)
CmdE:	cpi		D,0x0E
		brne	CmdD
		rcall	ResetAllTables
		ret
;D     UART
CmdD:	cpi		D,0x0D
		brne	CmdC
		sbr		Status,UARTCtrl
		ret
;      FLASH c     OUZMinFP8....OUZMaxFP8
CmdC:	cpi		D,0x0C
		brne	CmdB
		rcall	LoadAllTable
		ret
;B     ()
CmdB:	cpi		D,0x0B
		brne	CmdA
		cbr		Status,UARTCtrl
		ret
;A      FLASH
CmdA:	cpi		D,0x0A
		brne	Cmd9
		rcall	SaveAllTable
		ret
;9     (8  tester)  
Cmd9:	cpi		D,0x09
		brne	Cmd8
		rcall	SendData
		ldi		D,8
		rcall	SendData
		lds		D,tester
		rcall	SendData
		lds		D,tester+1
		rcall	SendData
		lds		D,tester+2
		rcall	SendData
		lds		D,tester+3
		rcall	SendData
		lds		D,tester+4
		rcall	SendData
		lds		D,tester+5
		rcall	SendData
		lds		D,tester+6
		rcall	SendData
		lds		D,tester+7
		rcall	SendData
		ret  
;8      Index
Cmd8:	cpi		D,0x08
		brne	Cmd7
		rcall	SendData
		ldi		D,64
		rcall	SendData
		ldi		XL,Low(Index)
		ldi		XH,High(Index)
		ldi		A,64
Cmd8_1:	ld		D,X+
		rcall	SendData
		dec		A
		brne	Cmd8_1
		ret
;7 
Cmd7:	cpi		D,0x07
		brne	Cmd6
		ret
;6    
Cmd6:	cpi		D,0x06
		brne	Cmd5
		rcall	SendData
		ldi		D,32
		rcall	SendData
		mov		A,UOZSelectr
		andi	A,UOZCount-1
		mul		D,A				;r1:r0 -  
		ldi		A,32
		ldi		XL,low(UOZ)				
		ldi		XH,High(UOZ)
		add		XL,r0
		adc		XH,r1
Cmd6_1:	ld		D,X+
		rcall	SendData
		dec		A
		brne	Cmd6_1
		ret
;5 
Cmd5:	cpi		D,0x05
		brne	Cmd4
		ret
;4 
Cmd4:	cpi		D,0x04
		brne	Cmd3
		ret
;3 
Cmd3:	cpi		D,0x03
		brne	Cmd2
		ret
;2 
Cmd2:	cpi		D,0x02
		brne	Cmd1
		ret
;1  : N(HL) Selectr UOZSelectr Status EStatus UOZCurrent(HL) TableAdress
Cmd1:	cpi		D,0x01
		brne	Cmd0
		rcall	SendData
		ldi		D,9
		rcall	SendData
		cli	
		push	Status
		push	UOZSelectr
		push	Selectr
		push	NL
		push	NH
		sei
		pop		D		
		rcall	SendData
		pop		D		
		rcall	SendData        
		pop		D		
		rcall	SendData
		pop		D		
		rcall	SendData 
		pop		D		
		rcall	SendData
		rcall	CheckUARTflags
		mov		D,Estatus
		rcall	SendData
		lds		D,UOZCurrent+1
		rcall	SendData
		lds		D,UOZCurrent
		rcall	SendData
		mov		D,TableAdress
		rcall	SendData
Cmd0:	ret  
;  
				
