;
; Onecycle.asm
;
; Created: 21.10.2020 19:04:16
; Author :   (for_dgf@mail.ru)
.include "m328pdef.inc"
;*******************************************************************************
;  B								
; PB0(icp)		xxx	!  
; PB1(osc1)		xxx	!  
; PB2(ss)		xxx	!  
; PB3(mosi)		xxx	!  
; PB4(miso)		xxx	!  
; PB5(sck)		xxx	!  
;*******************************************************************************
;  D 
; PD0(rxd)		xxx	!  
; PD1(txd)		xxx	!  
; PD2(int0)		in	!			;  (  )
; PD3(int1)		xxx	!					
; PD4(t0)		xxx	!					
; PD5(t1)		xxx	!					
; PD6(ain0)		xxx	!
; PD7(ain1)		xxx	!
;*******************************************************************************
;  C	
; PC0(adc0)		xxx	!
; PC1(adc1)		xxx	!					  
; PC2(adc2)		out	!			;  - CDI 
; PC3(adc3)		out	!			;  - TCI 
; PC4(adc4/scl)	xxx	!
; PC5(adc5/sda)	xxx	!					
.dseg
.org 0x100

.equ	Version		= 33				;  28.11.2020 

;!!!  

;!    8 =FP8.    16 =FP16
;     : FP8 = float  128;  FP16 = float  32768

;LDelta=39,0 . 
.equ	LDelta		= 39				;      LDelta   
.equ	LDeltaFP16	= 0				; (0*32768)      LDelta   

; UOZ      !   =   + !
.equ	Base		= 360				;-   
;     Base-LDelta    
;    LDelta     .        .
; ,     ,       LDelta -  LowMode.
.equ	Fn		= 7				;  ,    1  - F = 8/(1+Fn)

.equ	InternalClk	= 2				;     F=2 (Fn=3),      SystemClk=InternalClk.
.equ	ExternalClk	= 7				;    SystemClk=ExternalClk.      
			 				;  D6 (OCA=PD6=AIN0)        D5 (T1=PD5=OCOB)

.equ	SystemClk	=	ExternalClk		;!!!   :  InternalClk  ExternalClk
										
; 1 ( 1) -     : 
; OUZFP8=128*Ka*[LDelta-Alfa]/[Base-LDelta]  
; -  0 <= Alfa,  < LDelta - 3 !!!
.equ	Ka		= 16				;  (!!!)
;        ,   OUZMaxFP8  <= 255 !!!.
.equ	OUZMaxFP8	= 249				;    Alfa=0  ( 1).
;           c  
.equ	OUZMinFP8	= 19				;    Alfa ( 1).    Alfa=32 .
.equ	UOZCount	= 4				;    2^N (1, 2, 4, 8, 16, 32)
.equ	StopCntMax 	= 61				;    .      StopCntMax * 65536/F. 
;F -   ,    1.       
;   StopCnt = StopCntMax.      
;(       )  StopCnt   . 
;,   ,  StopCnt   0! 

.equ	AlfaT		= 12				;          LDELTA
							;AlfaT=256*Alfa/[Base-LDelta],  Alfa    . 

;    
.equ	ProtectClk	= 6				;        
.equ	Maskchain	= 0b00000111			;-   .  0b00000111 -   3 ! 
.equ	ProtectCorr 	= 19				;         .
;ProtectCorr = ([ "1"  Maskchain-1] * ProtectTime + 7)*8/(1+Fn) = 19

;      
.equ	OUZCanBit	= 4				;!!!   ,       .
;        500   +5 Arduino.
;       2^N (2,4,8,16,32)    LDELTA
.equ	OUZAverCount	= 8				;!!!      OUZAver
;        OUZAver.
;       OUZSelectr 
;  ,         .

.equ	StartADCCmd	= 0b11000111			;      ~104 .  
.equ	ADCnotRdy	= 0x40				;,   ADCSRA.ADSC= 6	
.equ	ADCnotRdyBit	= 6				

;     
;         
;   3  , 2  ,1  ,  .
.equ	StartLDelta 	= 0b1010			;   LDelta
.equ	StopLDelta 	= 0b0101			;   LDelta

;   !!!!! 
.equ	CmdCDILineBit= 3				;!!!    CDI
.equ	CmdTCILineBit= 2				;!!!    TCI

; 
	                                    		;     Status
.equ	LowMode		= 0x80            
.equ	StopMode	= 0x40			
.equ	OUZMax		= 0x20            
.equ	OUZMin		= 0x10            
.equ	Ign		= 0x08	
.equ	DH		= 0x04		
.equ	Protect		= 0x02
.equ	UARTCtrl	= 0x01            

.equ	LowModeBit	= 0x07
.equ	StopModeBit	= 0x06
.equ	OUZMaxBit	= 0x05
.equ	OUZMinBit	= 0x04			
.equ	IgnBit		= 0x03
.equ	DHBit		= 0x02
.equ	ProtectBit	= 0x01
.equ	UARTCtrlBit	= 0x00
                                        		;     EStatus
.equ	RError		= 0x80            
.equ	RnewCMD		= 0x40            
.equ	TError		= 0x20            
.equ	TnotEmpty	= 0x10			

.equ	RErrorBit	= 0x07
.equ	RnewCMDBit	= 0x06
.equ	TErrorBit	= 0x05			
.equ	TnotEmptyBit	= 0x04
										
.equ	DHEvent		= 0x01				;      Event
;************************************** 
UOZ:			.byte	32*UOZCount		;FP8.    ( 32 ).
Index:			.byte	64			;  
UOZCurrent:		.byte	2			;FP16.  . 
Rbuff:			.byte	256			;   
Tbuff:			.byte	256			;   
RptrI:			.byte	1			;     
RptrO:			.byte	1			;       RptrO=RptrI,     !!!
TptrI:			.byte	1			;     
TptrO:			.byte	1			;       TptrO=TptrI,     !!!
OUZAver:		.byte	OUZAverCount 	  	; 
ADCptr:			.byte	1			;     
tester:			.byte	8			;  

;************************************** 
.def	Status		= r23				;   ( *    )
							;7 *LowMode -    
							;6 *StopMode -  
							;5 *UOZMax -  OUZ   
							;4 *OUZMin -  OUZ  
							;3 Ign	 -   	
							;2 DH -   
							;1 Protect -       
							;0 *UARTCtrl -   UOZSelectr: 0 -   (), 1 -  UART
.def	EStatus		= r24				;  
							;7 RError -   
							;6 *RnewCMD -     
							;5 TError -   
							;4 TnotEmpty -     	 
							;3 Events DH[n-3]
							;2 Events DH[n-2]
							;1 Events DH[n-1]
							;0 Events DH[n-0]
							;  Events -  . C  DH    .
.def	UOZSelectr	= r16				;UOZSelectr										
;***********************************	  !!!!!!!!
; ZH, ZL, temp         
.def	NL		= r14				;   -  
.def	NH		= r15				;   -  
.def	temp		= r17				; 
.def	PSREG		= r5				;   SREG
.def	RMaskchain	= r4 				;,  -  .
.def	Selectr		= r18				;    UOZ
.def	zerro		= r12				;  0x00!!!
.def	full		= r13				;  0xFF!!!
.def	DHChain		= r3				;       
.def	DeltaL		= r7				;  Seletr 
.def	DeltaH		= r8
.def	RaznostL	= r9				;       
.def	RaznostH	= r10
.def	TableAdress 	= r11				;  /   UART
.def	StopCnt		= r25                		;    
;***********************************	 
.def	A		= r19				; r0, r1, r2, r6, XL, XH, YL, YH
.def	B		= r20				
.def	C		= r21		
.def	D		= r22
;***********************************	
.Macro	CmdCDI_ON					
	sbi	PORTC,CmdCDILineBit
.EndMacro
.Macro	CmdCDI_OFF					
	cbi	PORTC,CmdCDILineBit
.EndMacro
.Macro	CmdTCI_ON					
	sbi	PORTC,CmdTCILineBit
.EndMacro
.Macro	CmdTCI_OFF					
	cbi	PORTC,CmdTCILineBit
.EndMacro
;  
.Macro	LEDport		                
;         -
; LEDPort PINC,0   -  ,  0      1
	sbis	@0,@1		
	cbi	PortB,5
	sbic	@0,@1		
	sbi	PortB,5
.EndMacro
.Macro	LEDreg
;        
; LEDreg Status,StopBit   -  ,   
	sbrs	@0,@1
	cbi	PortB,5
	sbrc	@0,@1
	sbi	PortB,5
.EndMacro
.Macro	pushSREG
	in	PSREG,SREG				
.EndMacro
.Macro	popSREG	
	out	SREG,PSREG
.EndMacro
.Macro	FTW
	ldi	A,@0
	st	-X,A
	ldi	A,@1
	st	-X,A
.EndMacro
.Macro	FTB
	ldi	A,@0
	st	-X,A
.EndMacro
.Macro	IncPtrA
	lds	A,@0
	inc	A
	sts	@0,A
.EndMacro
.Macro	pusha
	push	XL
	push	XH
	push	YL
	push	YH
	push	r0
	push	r1
	push	A
	push	B
	push	C
	push	D
.EndMacro
.Macro	popa
	pop	D
	pop	C
	pop	B
	pop	A
	pop	r1
	pop	r0
	pop	YH
	pop	YL
	pop	XH
	pop	XL
.EndMacro
;***********************************
.CSEG
.org 0x00								
	jmp	reset					;  bootsection Bootrst =  (0) 300h    . 
	jmp	LinesCNHG				;    (IRQ0)
	jmp	Empty_int				;IRQ1
	jmp	Empty_int				;PCINT0
	jmp	Empty_int				;PCINT1
	jmp	Empty_int				;PCINT2
	jmp	Empty_int				;Watchdog Timer
	jmp	Protecter				;     (Timer2 Compare A)
	jmp	Empty_int				;Timer2 Compare B
	jmp	Empty_int				;Timer2 Overflow
	jmp	Empty_int				;Timer1 Capture
	jmp	Ignition_int				;    (Timer1 Compare A)
	jmp	Empty_int				;Timer1 Compare B
	jmp	Empty_int				;Timer1 Overflow
	jmp	Empty_int				;Timer0 Compare A
	jmp	Empty_int				;Timer0 Compare B
	jmp	Empty_int				;Timer0 Overflow
	jmp	Empty_int				;SPI Transfer Complete
	jmp	RX_OK					;USART, RX Complete
	jmp	Empty_int				;USART, UDR Empty
	jmp	Empty_int				;USART, TX Complete
	jmp	Empty_int				;ADC Conversion Complete
	jmp	Empty_int				;EEPROM Ready Handler
	jmp	Empty_int				;Analog Comparator Handler
	jmp	Empty_int				;2-wire Serial Interface Handler
	jmp	Empty_int				;Store Program Memory Ready Handler
;*******************************************************************************
reset:
	cli
	clr	zerro
	mov	full,zerro
	com	full
	ldi	A,Low(RAMEND)		
	out	SPL,A
	ldi	A,High(RAMEND)
	out	SPH,A
	in	A,MCUCR			
	cbr	A,PUD					;    PUD=0 (    )
	mov	B,A
	sbr	A,IVCE					;         IVCE=1
	out	MCUCR,A
	cbr	B,IVSEL					;IVSEL=0
	out	MCUCR,B
	out	DDRB,zerro				; 
	out	DDRC,zerro				; 
	out	DDRD,zerro				; 
	out	PORTB,full				;    +5 (PUD=0)
	out	PORTC,full				;    +5 (PUD=0)
	out	PORTD,full				;    +5 (PUD=0)
	sbi	DDRC,CmdCDILineBit			;
	sbi	DDRC,CmdTCILineBit			;
	sbi	DDRB,5					;  
	CmdCDI_OFF					;   CDI
	CmdTCI_OFF					;   TCI
	cbi	PortB,5
	clr	XH						
	ldi	A,0b00000001				;     
	ldi	XL,EICRA				;   EICRA   Z
    st	X,A		
	sbi	EIMSK,0 				; int0 
	out	EIFR,full				;    int0 
	ldi	XL,TCCR1A				;   
	st	X,zerro					;  Normal (0)
	ldi	XL,TCCR1B
	ldi	A,SystemClk				;   
	st	X,A	                       	
	ldi	XL,TIMSK1
	ldi	A,0x2					;      OCRA
	st	X,A	
	ldi	XL,TCCR2A				;      
	ldi	A,0b00000010		
	st	X+,A					;  - CTC
	st	X+,zerro				;TCCR2B -   ( 2  )
	st	X+,zerro				;TC2 = 0
	ldi	A,ProtectClk				;    
	lsl	A
	dec	A					
	st	X+,A					;OCR2A=2*ProtectClk-1
	ldi	XL,TIMSK2
	ldi	A,0x2					;      OCRA
	st	X,A	
	ldi	XL,Low(Index)				;  Index
	ldi	XH,High(Index)
	adiw	X,32
	adiw	X,32
	rcall	FillIndex
	ldi	Selectr,0x1f
	clr	Status
	clr	EStatus					;    
	sbic	PinD,DHBit
	sbr	Status,DH
	sbic	PinD,DHBit
	sbr	EStatus,DHEvent				;EStatus=[0,0,0,0,0,0,0,DH]
	sbr	Status,LowMode
	rcall	UARTInit				; UART
	ldi	A,Maskchain
	mov	RMaskchain,A
	ldi	UOZSelectr,UOZCount-1
	rcall	LoadAllTable

	clr	XH					; . 
	ldi	XL,DIDR0				;     .
	ldi	A,(1<<OUZCanBit)				
	st	X,A						
	ldi	XL,ADMUX
	ldi	A,0b01100000+OUZCanBit			;   
	st	X,A
	ldi	A,StartADCCmd				;      ~104 .   .
	ldi	XL,ADCSRA
	st	X,A
	ldi	XL,Low(OUZAver)
	ldi	XH,High(OUZAver)
	ldi	B,OUZAverCount
	add	XL,B
	adc	XH,zerro
res_1:	FTB	0xFF
	dec	B
	brne	res_1
	sts	ADCptr,zerro
	sts	tester,zerro
	sts	tester+1,zerro
	sts	tester+2,zerro
	sts	tester+3,zerro
	sts	tester+4,zerro
	sts	tester+5,zerro
	sts	tester+6,zerro
	sts	tester+7,zerro

	ldi	A,SystemClk
	cpi	A,InternalClk
	breq	res_2
;   ExternalClk 
	sbi	DDRD,PIND6			
	ldi	A,0b01000010		
	out	TCCR0A,A			
	ldi	A,0b00000001		
	out	TCCR0B,A			
	ldi	A,Fn 					;F = 8/(1+Fn) = 2 
	out	OCR0A,A				
;!!!    D6 (OCA=PD6=AIN0)        D5 (T1=PD5=OCOB)
res_2:	
	sei

;  
loop:	LEDreg	Status,UARTCtrlBit
	rcall	ADCProcessIFStopMode
	rcall	UOZControl
	rcall	UARTMODE
	rjmp	loop

UOZControl:	
	sbrc	Status,UARTCtrlBit
	ret
;      ,    . 
;      UART 0xOD!      !
;          UART 0xOB!
	ldi	XL,Low(OUZAver)
	ldi	XH,High(OUZAver)
	mov	A,zerro
	mov	B,zerro
	mov	C,zerro
loop1:	ld	D,X+
	add	A,D
	adc	B,zerro
	inc	C
	cpi	C,OUZAverCount
	brne	loop1
	lsr	C
loop2:  lsr	B						
	ror	A
	lsr	C
	brne	loop2
	ldi	D,64
	lsr	A   
	lsr	A   
loop3:	lsr	A   
	lsr	D   
	cpi	D,UOZCount
	brne	loop3
	andi	A,UOZCount-1
	mov	UOZSelectr,A
	ret

;***************************************************************************************
;     
;************************************************************************************************
Protecter:      
	sbrs	Status,ProtectBit			;     
	reti
	pushSREG	
	in	temp,PinD				
	lsl	DHChain				
	and	DHChain,RMaskchain	
	sbrc	temp,DHBit			
	inc	DHChain				
CheckStartChain:					;     
	cp	DHChain,zerro			
	breq	CreateEvents0				;"" 0 
	cp	DHChain,RMaskchain
	breq	CreateEvents1				;"" 1 
	popSREG
	reti
CreateEvents0:
	nop
	nop
CreateEvents1:
	clr	ZH
	ldi	ZL,TCCR2B				;       							
	st	Z+,zerro				;       
	st	Z,zerro					;TC2 = 0
	cbr	Status,Protect				;  
	mov	temp,Status				;     
	andi	temp,DH		    
	sbrc	DHChain,0       
	subi	temp,DH
	breq	iret					;  0,  !
	cbr	Status,DH				;Status=[X,X,X,X,X,0,X,X]
	sbrc	DHChain,0
	sbr	Status,DH				;Status=[X,X,X,X,X,DH,X,X]
	mov	temp,EStatus				;   Events 
	lsl	temp					
	andi	temp,0x0F				;temp=[0,0,0,0,DH(n-3),DH(n-2),DH(n-1),0]		
	sbrc	Status,DHBit						
	sbr	temp,DHEvent				;temp=[0,0,0,0,DH(n-3),DH(n-2),DH(n-1),DH]		
	andi	EStatus,0xF0
	add	EStatus,temp				;EStatus=[X,X,X,X,DH(n-3),DH(n-2),DH(n-1),DH]		
; 			  :
;0000xxxx -				     
;00001010   		NH:NL FindSelectr StartIgnition  Ign=1
;00000101   	CmdLine_ON Ign=0
C_StopCnt:      					
;!!!    tn=0  
	ldi	StopCnt,StopCntMax
	cbr	Status,StopMode				;  
	clr	ZH
	ldi	ZL,TCCR1B				
	st	Z,zerro					; -
	ldi	ZL,TCNT1L				
C_Start:
	cpi	temp,StartLDelta
	brne	C_Stop
	ld	NL,Z+					
	ld	NH,Z			    		;TCNT1H 
	st	Z,zerro					; -
	st	-Z,zerro								
	sts	tester+4,NH
	sts	tester+5,NL
	cbr	Status,LowMode				; 
	sbic	TIFR1,0					;   ,    	
	rcall	SetLowMode
	sbi	TIFR1,0					;   
	ldi	ZL,TCCR1B		
	ldi	temp,SystemClk
	st	Z,temp					; -
;!!!    tn=2  				
	CmdCDI_OFF						;      AlfaT    ,       
	CmdTCI_ON						
	rcall	StartADC
	rcall	FindSelectr				
	rcall	StartIgnition				;     . 
	sbr	Status,Ign
iret:	popSREG
Empty_int:								
	reti

SetStopMode:
	sbr	Status,StopMode				; 
	cbr	Status,Ign
	CmdCDI_OFF
	CmdTCI_OFF						
	ldi	ZL,Low(OUZAver)				;   
	ldi	ZH,High(OUZAver)
	clr	temp
SSM1:	
	st	Z+,full
	inc	temp
	cpi	temp,OUZAverCount
	brne	SSM1
SetLowMode:
	sbr	Status,LowMode				; " "
	ldi	temp,OUZMaxFP8
	sts	UOZCurrent+1,temp
	sts	UOZCurrent,zerro
	mov	NL,full
	mov	NH,full
	ret

C_Stop:	
	cpi	temp,StopLDelta
	brne	iret
	ld	temp,Z+		
	sts	tester+7,temp				
	ld	temp,Z			    	;	TCNT1H 
	sts	tester+6,temp				
	st	Z,zerro					; -
	st	-Z,zerro								
	sbi	TIFR1,1					;  OCRFA
	ldi	ZL,TCCR1B		
	ldi	temp,SystemClk
	st	Z,temp					; -
;!!!    tn=2  			
	CmdCDI_ON					;  		
	CmdTCI_OFF						
	cbr	Status,Ign
	rcall	ReadADC
	push 	r0
	push 	r1
	ldi	temp,AlfaT
	mul	temp,NH
	clr	ZH
	ldi	ZL,OCR1AH				;    
	st	Z,r1
	st	-Z,r0
	pop	r1
	pop	r0
	popSREG
	reti


LinesCNHG:						;  !!!!
	sbrc	Status,ProtectBit			;     ,  
	reti
	pushSREG
	clr	ZH
	ldi	ZL,TCCR2B				;      
	ldi	temp,2					;0-off, 1-16MHz, 2-2MHz
	st	Z+,temp					
	st	Z,zerro					;TC2 = 0
	mov	DHChain,zerro				;PinX=1 ->  Chain=00000001  PinX=0 ->  Chain=11111110
	inc	DHChain					;     -   
	sbis	PinD,DHBit				;   -    
	com	DHChain		  			
	sbr	Status,Protect		
	popSREG
	reti
		
Ignition_int:   
	sbrc 	Status,StopModeBit	
	reti	
	pushSREG						;  .      
	dec 	StopCnt
	brne 	I_I1
	rcall 	SetStopMode
	popSREG
	reti
I_I1:   popSREG
	sbrc 	Status,IgnBit
	rjmp 	I_ON
	CmdCDI_OFF						;   CDI
								; ,     TCI      
	CmdTCI_ON	;!!!					;   .      
								; TCI         CDI.
	reti
I_ON:   sbrc	Status,LowModeBit	
	reti
	CmdCDI_ON						;	
	CmdTCI_OFF
	reti

FindSelectr: 	
	ldi	Selectr,0x1F			
	sbrc	Status,LowModeBit
	ret
	ldi	ZL,Low(Index)
	ldi	ZH,High(Index)
	ser	Selectr					
FS_1:	inc	Selectr
	ld	RaznostL,Z+
	ld	RaznostH,Z+
	mov	DeltaL,RaznostL
	mov	DeltaH,RaznostH
	sub	RaznostL,NL
	sbc	RaznostH,NH
	brcs	FS_1
	ld	temp,-Z			
	ld	temp,-Z			
	ld	temp,-Z
	push	temp			
	ld	temp,-Z
	sub	DeltaL,temp
	pop	temp
	sbc	DeltaH,temp
	dec	Selectr
	ret

StartIgnition:						;     "" 
; 2 ( 2) - Code = N * [Yp*Raznost/Delta + Yk *(1-Raznost/Delta)] / Ka 
	sbrc	Status,LowModeBit			;   " "    Stop!!!!
	ret			
	sbrc	Selectr,0x7				;   
	rjmp	HighRotor				;    ,          
	pusha
	clr	C						
	clr	A
	clr	B
	clr	D
	ldi	temp,24
SI_1:	lsl	C
	rol	RaznostL
	rol	RaznostH
	rol	A
	rol	B
	rol	D
	cp	A,DeltaL
	cpc	B,DeltaH
	cpc	D,zerro
	brcs	SI_2
	inc	C
	sub	A,DeltaL
	sbc	B,DeltaH
	sbc	D,zerro
SI_2:	dec	temp
	brne	SI_1
	lsr	RaznostL
	ror	C
	ldi	B,0b10000000				;C=(n-p)/Delta
	sub	B,C					;B=1-(n-p)/Delta
	ldi	ZL,Low(UOZ)
	ldi	ZH,High(UOZ)            		;    
	mov	A,UOZSelectr				;  
	andi	A,UOZCount-1
	ldi	D,32
	mul	A,D
	add	r0,Selectr              		;    
	adc	r1,zerro
	add	ZL,r0
	adc	ZH,r1
	ld	A,Z+					;Yp
	fmul	A,C
	push	r1
	push	r0
	ld	A,Z					;Yk
	fmul	A,B
	pop	A
	add	A,r0
	pop	B
	adc	B,r1
;FP16 UOZCurrent(B:A) = Yp*Raznost/Delta + Yk *(1-Raznost/Delta)
CheckBounds:	
	cbr	Status,OUZMax+OUZMin
	ldi	C,OUZMinFP8				;      OUZMinFP8(2)....OUZMaxFP8(166)
	sub	C,B			
	brcs	CB_1
	ldi	B,OUZMinFP8
	clr	A
	sbr	Status,OUZMin
CB_1:	ldi	C,OUZMaxFP8
	sub	C,B			
	brcc	CB_2
	ldi	B,OUZMaxFP8	
	clr	A
	sbr	Status,OUZMax
; 2 ( 2) - Code = N * [Yp*Raznost/Delta + Yk *(1-Raznost/Delta)] / Ka
CB_2:	sts	UOZCurrent,A
	sts	UOZCurrent+1,B
;    - !!!!
	mov	D,NL					;B:A - 		
	mov	C,NH					;C:D - 
	mul	A,D					; .    .  
	movw	r27:r26,r1:r0				;r29:r28 1-, 2-   ()
	mul	B,C					; .    .  
	movw	r29:r28,r1:r0				; r1:r0  3-, 4-   ()
	mul	B,D					; .    .  
	add	r27,r0					; r0:r1:r16  2-, 3-, 4-  
	adc	r28,r1					
	adc	r29,zerro					
	mul	A,C					; .    .  
	add	r27,r0					; r0:r1:r16  2-, 3-, 4-  
	adc	r28,r1					
	adc	r29,zerro				;29:28:27:26		
;      Ka
;************************************* Ka  
	ldi	A,Ka
	lsr	A
	clr	C 
	clr	D         
	ldi	B,16   
CB_3:	lsl	r28    
	rol	r29    
	rol	C      
	rol	D
	sub	C,A	   
	sbc	D,zerro 
	ori	r28,0x01
	brcc	CB_4
	add	C,A   
	adc	D,zerro
	andi	r28,0xFE     
CB_4:	dec	B         
	brne	CB_3
;   15          - 68  
; Ka=2, 4, 8, 16 ,32        
;************************************* Ka=2			
;	nop 		
;************************************* Ka=4
;	lsr	r29		
;	ror	r28						
;************************************* Ka=8
;	lsr	r29		
;	ror	r28						
;	lsr	r29						
;	ror	r28						
;************************************* Ka=16
;	lsr	r29		
;	ror	r28						
;	lsr	r29						
;	ror	r28						
;	lsr	r29						
;	ror	r28					
;************************************* Ka=32
;	lsr	r29		
;	ror	r28						
;	lsr	r29						
;	ror	r28						
;	lsr	r29						
;	ror	r28					
;	lsr	r29						
;	ror	r28					
;*************************************	
	subi 	r28,ProtectCorr				;!!!         .
	sbc	r29,zerro
	clr	ZH		
	ldi	ZL,OCR1AH				
	st	Z,r29
	st	-Z,r28
;  (  2    )     ,    
	ldi	ZL,TCNT1L				
	ld	r26,Z+					
	ld	r27,Z+			    	
	ldi	A,2
	add	r26,A
	adc	r27,zerro
	sub	r28,r26
	sbc	r29,r27
	brcc 	CB_5
	CmdCDI_ON					;  		
	CmdTCI_OFF						
	sbr	Status,OUZMin				;!!!   !!!
CB_5:
	popa
	ret

HighRotor:   
	pusha
	ldi	ZL,Low(UOZ)
	ldi	ZH,High(UOZ)
	mov	A,UOZSelectr				;  
	andi	A,UOZCount-1
	ldi	D,32
	mul	A,D
	add	ZL,r0
	adc	ZH,r1
	ld	B,Z					;      UOZCurrent
	clr	A
	rjmp	CheckBounds
;******************************************************
; 
;******************************************************    
ReadADC:		
	push	YH
	push	YL
	push	A
	push	B
	clr	YH						
;	ldi	YL,ADCL					
;	ld	A,Y						
	ldi	YL,ADCH					 ;          OUZAver
	ld	B,Y					 ; OUZAverCount
	lds	A,ADCptr
	inc	A
	andi	A,OUZAverCount-1
	sts	ADCptr,A
	ldi	YL,Low(OUZAver)
	ldi	YH,High(OUZAver)
	add	YL,A
	adc	YH,zerro
	st	Y,B
	pop	B
	pop	A
	pop	YL
	pop	YH
	ret	
StartADC:						 ;  
	push	YH
	push	YL
	push	A
	clr	YH						
	ldi	A,StartADCCmd
	ldi	YL,ADCSRA
	st	Y,A
	pop	A
	pop	YL
	pop	YH
	ret
ADCProcessIFStopMode:		
	sbrs	Status,StopModeBit
	ret					
	clr	YH						
	ldi	A,StartADCCmd
	ldi	YL,ADCSRA
	st	Y,A
	ldi	YL,ADCSRA
waitADCRdy:
	ld	A,Y
	sbrc	A,ADCnotRdyBit
	rjmp	waitADCRdy
	ldi	YL,ADCH					
	ld	B,Y			
	lds	A,ADCptr
	inc	A
	andi	A,OUZAverCount-1
	sts	ADCptr,A
	ldi	YL,Low(OUZAver)
	ldi	YH,High(OUZAver)
	add	YL,A
	adc	YH,zerro
	st	Y,B
	ret
;******************************************************      
FillIndex:		
	FTW	0xFF,0xFF
	FTW	0xD0,0xFC
	FTW	0x82,0x9D
	FTW	0x7A,0xEE
	FTW	0x74,0x1A
	FTW	0x6D,0xFD
	FTW	0x68,0x7E
	FTW	0x63,0x84
	FTW	0x5E,0xFE
	FTW	0x5A,0xDC
	FTW	0x53,0x98
	FTW	0x4D,0x66
	FTW	0x48,0x10
	FTW	0x43,0x6A
	FTW	0x3F,0x54
	FTW	0x3B,0xB5
	FTW	0x38,0x7B
	FTW	0x35,0x95
	FTW	0x32,0xF8
	FTW	0x30,0x99
	FTW	0x2E,0x70
	FTW	0x2C,0x76
	FTW	0x2A,0xA6
	FTW	0x28,0xFA
	FTW	0x27,0x6E
	FTW	0x25,0xFF
	FTW	0x22,0xD4
	FTW	0x21,0xB5
	FTW	0x1D,0xDA
	FTW	0x1A,0x1F
	FTW	0x17,0x38
	FTW	0x14,0xE6
	ret


FillTable:
	FTB	0xD3
	FTB	0xAC
	FTB	0xA6
	FTB	0xA3
	FTB	0xA0
	FTB	0x9C
	FTB	0x99
	FTB	0x96
	FTB	0x93
	FTB	0x90
	FTB	0x8C
	FTB	0x89
	FTB	0x86
	FTB	0x83
	FTB	0x80
	FTB	0x7C
	FTB	0x79
	FTB	0x73
	FTB	0x6C
	FTB	0x66
	FTB	0x60
	FTB	0x5D
	FTB	0x59
	FTB	0x53
	FTB	0x4D
	FTB	0x46
	FTB	0x40
	FTB	0x39
	FTB	0x33
	FTB	0x2D
	FTB	0x26
	FTB	0x40
	ret

.include "eeprom&uart.inc"
