unit UOZ_main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls,
  ComCtrls, Menus, ActnList, Buttons, EditBtn, TAGraph, TASources, TASeries,
  TATransformations, UOZ_sys, SdpoSerial, Types, COM_sys, LConvEncoding;

type

  { TForm1 }

  TForm1 = class(TForm)
    com0A: TButton;
    com0C: TButton;
    label3: TLabel;
    label2: TLabel;
    SavetoDisk: TButton;
    LoadfromDisk: TButton;
    comA0: TButton;
    comE0: TButton;
    comC0: TButton;
    fAutoCtrl: TCheckBox;
    fLowMode: TShape;
    fOUZSelectr: TTrackBar;
    fStopMode: TShape;
    Axis: TGroupBox;
    lb_No: TLabel;
    MetkaX: TShape;
    MetkaY: TShape;
    PA: TPanel;
    fN0: TRadioGroup;
    Panel: TCheckGroup;
    lb_alfa: TLabel;
    OD: TOpenDialog;
    Panel1: TPanel;
    fOUZ: TRadioGroup;
    fOUZControl: TRadioGroup;
    com0E: TButton;
    SD: TSaveDialog;
    serial: TSdpoSerial;
    fOUZMax: TShape;
    fOUZMin: TShape;
    timer: TTimer;
    procedure com0AClick(Sender: TObject);
    procedure com0CClick(Sender: TObject);
    procedure com0EClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure SavetoDiskClick(Sender: TObject);
    procedure LoadfromDiskClick(Sender: TObject);
    procedure comA0Click(Sender: TObject);
    procedure comC0Click(Sender: TObject);
    procedure comE0Click(Sender: TObject);
    procedure fAutoCtrlChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormWindowStateChange(Sender: TObject);
    procedure fOUZSelectrChange(Sender: TObject);

    procedure PAMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PAMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure PAMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PAMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure serialRxData(Sender: TObject);
    procedure timerTimer(Sender: TObject);

  private

  public

  end;

var
  Form1: TForm1;
  ax,bx,ay,by:extended;
  xmin,xmax,ymin,ymax:integer;
  UOZptr:integer;
  MovePoint:boolean;
  StartDir:string;

procedure DoAction;
Function GetData:boolean;
Procedure AutoSaveOUZ;

implementation

{$R *.lfm}

{ TForm1 }


Procedure Wait(Cnt:longint);
begin
   if Cnt=0 then exit;
   WDT.Cnt:=SystemCnt+Cnt; WDT.Delay:=true;
   while WDT.Delay do application.ProcessMessages;
end;


procedure RedrawAll;
var y,i,x,j,y_:integer;
    x1,x2,y1,y2:integer;
    aa:integer;
    txt:string;

begin
 if not Core.LoadParam then exit;
 if not ChangeValue then exit;
 Form1.MetkaX.visible:=false;
 if Core.Selectr in [0..$1F] then Form1.MetkaX.visible:=true;
 Form1.MetkaY.visible:=Form1.MetkaX.visible;
 Form1.PA.Canvas.Clear;
 Form1.PA.refresh;
 with Form1.PA.Canvas do
    begin
      Pen.Width:=2; Brush.Color:=Form1.PA.color;
      Pen.Color:= clBlack; txt:='УОЗ,грд';
      xmin:=textwidth(txt)+10; xmax:=width;
      ymin:=10; ymax:=Height-textHeight(txt)-10;

      moveto(xmin,ymax); lineto(xmax,ymax);
      moveto(xmax-20,ymax-3); lineto(xmax,ymax); lineto(xmax-20,ymax+3);
      moveto(xmin,ymax); lineto(xmin,ymin);
      moveto(xmin-3,ymin+20); lineto(xmin,ymin); lineto(xmin+3,ymin+20);
      ymin:=ymin+20;
      ay:=(ymin-ymax)/(Core.OUZMinFP8-Core.OUZMaxFP8); by:=ymin-ay*Core.OUZMinFP8;
      ax:=(xmax-xmin)/(Nmax-Nmin); bx:=xmax-ax*Nmax;
      txt:='1.6';
      i:=round(ax*NC[PCount-1]+bx);
      moveto(i,ymax-3); lineto(i,ymax+3);
      y_:=ymax+5;
      for j:=PCount-1 downto 0 do
          begin
                 i:=round(ax*NC[j]+bx);
                 moveto(i,ymax-3); lineto(i,ymax+3);
                 textout(i-textwidth(txt)div 2,y_,floattostrf(NC[j]/1000,ffFixed,4,1));
                 if y_=ymax+5 then y_:=ymax-20 else y_:=ymax+5
          end;
      for j:=1 downto 0 do
          begin
                 i:=round(ax*NC[j]+bx);
                 moveto(i,ymax-3); lineto(i,ymax+3);
          end;
      txt:='тыс.об./мин'; textout(Width-textwidth(txt)-5,ymax+5,txt);
      y:=0; txt:='45';
      repeat
        aa:=AlfatoOUZFP8(y);
        i:=round(ay*aa+by);
        moveto(xmin-3,i); lineto(xmin+3,i);
        textout(xmin-textwidth(txt)-10,i-textHeight(txt) div 2,inttostr(y));
        y:=y+5;
     until y>Core.AlfaMax;
      aa:=AlfatoOUZFP8(y);
      i:=round(ay*aa+by); txt:='УОЗ,грд';
      textout(xmin-textwidth(txt)-5,i-textHeight(txt) div 2,txt);
      form1.MetkaY.Left:=xmin+3;form1.Metkay.width:=xmax-xmin;
      aa:=round(Core.UOZCurrentFP16/256);
      form1.MetkaY.Top:=round(ay*aa+by)-2;
      form1.MetkaX.Top:=ymin; form1.MetkaX.height:=ymax-form1.MetkaX.Top-7;
      form1.MetkaX.left:=round(ax*Core.No+bx)-2;
      for i:=0 to PCount-1 do NScr[i]:=round(ax*NC[i]+bx);

      Brush.Style:=bsSolid;
      Pen.Width:=2; Pen.Color:=clBlack;
      for j:=0 to Core.UOZCount-1 do
          if j<>Core.UOZSelectr then
                                  begin
                                    for i:=0 to PCount-1 do AScr[j,i]:=round(ay*Core.UOZ[j,i]+by);
                                    moveto(NScr[0],AScr[j,0]);
                                    for i:=1 to PCount-1 do lineto(NScr[i],AScr[j,i]);
                                  end;
      Pen.Width:=3; Pen.Color:=clBlue; j:=Core.UOZSelectr;
      for i:=0 to PCount-1 do AScr[j,i]:=round(ay*Core.UOZ[j,i]+by);
      moveto(NScr[0],AScr[j,0]);
      for i:=1 to PCount-1 do lineto(NScr[i],AScr[j,i]);


      j:=Core.UOZSelectr;
      Brush.Color:=clBlue; Pen.Color:=clBlue;
      for i:=0 to PCount-1 do
          if i<>UOZptr then
                         begin
                          x1:=NScr[i]-5; x2:=x1+10;
                          y1:=AScr[j,i]-5; y2:=y1+10;
                          Rectangle(x1,y1,x2,y2);
                         end;
      Brush.Color:=clRED; Pen.Color:=clRED;
      i:=UOZptr;
      x1:=NScr[i]-5; x2:=x1+10;
      y1:=AScr[j,i]-5; y2:=y1+10;
      Rectangle(x1,y1,x2,y2);

      Brush.Color:=Form1.PA.color;
      Pen.Color:=clBlack;
      txt:='';
      aa:=AlfatoOUZFP8(Core.AlfaMax);
      j:=round(ay*aa+by);
      txt:=txt+'N='+inttostr(NC[UOZptr])+' 1/мин';
      txt:=txt+'  УОЗ='+floattostrf(OUZFP8toAlfa(Core.UOZ[Core.UOZSelectr,UOZptr]),ffFixed,6,2)+' грд';
      textout(xmin+20,j-textHeight(txt) div 2,txt);
      ChangeValue:=false;
      Brush.Color:=clWhite;
    end;
end;


procedure TForm1.FormCreate(Sender: TObject);
var a:string;
    i,k,RCmd, RLength, RError:integer;
    ukj,ukj1:byte;
    aa:Tsvect;
    COMdetect:boolean;
begin
COMdetect:=false;
if not FindCOM(AA) then
                         begin
                           ShowMessage('Подключенных устройств не найдено');
                           halt(0);
                         end;
i:=1;
repeat
    if AA[i]<>'' then
     begin
       Serial.Device:=AA[i];
       Serial.Active:=true;
       wait(10);
       SendCommand(UResetUART); TrasmiteCommand(Serial);
       wait(1);
       SendCommand(UGetConst);  TrasmiteCommand(Serial);
       wait(2);
       if Core.LoadConst then
             begin
               COMdetect:=true;
               form1.caption:='Настройка микропроцессорного зажигания.   Версия прошивки: '+Versions[Core.Version];
             end;
       if not COMdetect then
                            begin
                              Serial.Close;
                              AA[i]:='';
                            end;
     end;
    inc(i);
until (i>10) or (COMdetect);
if not COMdetect then
                         begin
                           ShowMessage('Подключенных устройств не найдено');
                           halt(0);
                         end;
SendCommand(UGetIndex);
TrasmiteCommand(Serial);
while not Core.LoadIndex do application.ProcessMessages;

for i:=0 to Core.UOZCount-1 do SendCommand(UGetTable+i);
TrasmiteCommand(Serial);
while not LoadAllCore do application.ProcessMessages;
SendCommand(UGetParam);
TrasmiteCommand(Serial);
while not Core.LoadParam do application.ProcessMessages;
GetStarted:=true;
fOUZSelectr.Position:=Core.UOZSelectr;
fOUZSelectr.enabled :=Core.UARTCtrl;
fAutoCtrl.checked   :=not Core.UARTCtrl;
GetStarted:=false;
end;



procedure TForm1.FormWindowStateChange(Sender: TObject);
begin
   ChangeValue:=true;
   RedrawAll;
end;


procedure TForm1.PAMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var i,ukj:integer;
begin
  if Button <> mbLeft then exit;
  ukj:=-1;
  for i:=0 to PCount-1 do
           if (abs(X-NScr[i])<=5) and (abs(Y-AScr[Core.UOZSelectr,i])<=5) then ukj:=i;
  if ukj>=0 then
                begin
                  UOZptr:=ukj;
                  SendCommand(USetAddr+UOZptr);
                  TrasmiteCommand(Serial);
                  MovePoint:=true;
                  ChangeValue:=true;
                  RedrawAll;
                end;
end;

procedure TForm1.PAMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button <> mbLeft then exit;
  MovePoint:=false;
end;


procedure TForm1.PAMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var ukj,dx:integer;
    DP:tpoint;
begin
if not MovePoint then exit;
if X>NScr[UOZptr]+5 then X:=NScr[UOZptr];
if X<NScr[UOZptr]-5 then X:=NScr[UOZptr];
with Core do
  begin
    if Y<AScr[UOZSelectr,UOZptr] then
                          begin
                            if UOZ[UOZSelectr,UOZptr]>OUZMinFP8 then
                                  begin
                                    dec(UOZ[UOZSelectr,UOZptr]);
                                    SendCommand(USetAddr+UOZptr);
                                    SendCommand(USetUOZH+(UOZ[UOZSelectr,UOZptr] shr 4));
                                    SendCommand(USetUOZL+(UOZ[UOZSelectr,UOZptr] and $F));
                                    TrasmiteCommand(Serial);
                                    ChangeValue:=true;
                                    RedrawAll;
                                  end;
                          end;
    if Y>AScr[Core.UOZSelectr,UOZptr] then
                          begin
                            if UOZ[UOZSelectr,UOZptr]<OUZMaxFP8 then
                                  begin
                                    inc(UOZ[UOZSelectr,UOZptr]);
                                    SendCommand(USetAddr+UOZptr);
                                    SendCommand(USetUOZH+(UOZ[UOZSelectr,UOZptr] shr 4));
                                    SendCommand(USetUOZL+(UOZ[UOZSelectr,UOZptr] and $F));
                                    TrasmiteCommand(Serial);
                                    ChangeValue:=true;
                                    RedrawAll;
                                  end;
                          end;
  end;
  DP.X:=X;   DP.Y:=Y;
  DP:=PA.ClientToScreen(DP);
  Mouse.CursorPos:=DP;
end;


procedure TForm1.PAMouseWheel(Sender: TObject; Shift: TShiftState;
  WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
begin
if UOZptr<0 then exit;
with Core do
  begin
  if WheelDelta>0 then
                     if UOZ[UOZSelectr,UOZptr]>OUZMinFP8 then
                           begin
                             dec(UOZ[UOZSelectr,UOZptr]);
                             SendCommand(USetAddr+UOZptr);
                             SendCommand(USetUOZH+(UOZ[UOZSelectr,UOZptr] shr 4));
                             SendCommand(USetUOZL+(UOZ[UOZSelectr,UOZptr] and $F));
                             TrasmiteCommand(Serial);
                             ChangeValue:=true;
                             RedrawAll;
                           end;
  if WheelDelta<0 then
                     if UOZ[UOZSelectr,UOZptr]<OUZMaxFP8 then
                           begin
                             inc(UOZ[UOZSelectr,UOZptr]);
                             SendCommand(USetAddr+UOZptr);
                             SendCommand(USetUOZH+(UOZ[UOZSelectr,UOZptr] shr 4));
                             SendCommand(USetUOZL+(UOZ[UOZSelectr,UOZptr] and $F));
                             TrasmiteCommand(Serial);
                             ChangeValue:=true;
                             RedrawAll;
                           end;
  end;
end;



  (*  if MessageDlg('Внимание! Восстановление параметров из EEPROM!',
     'Выполнить?', mtConfirmation,[mbYes, mbNo],0) = mrNO then exit;
  Wait;
  SendCommand(ULoadParam);
  SendCommand(UGetUOZ);*)


//SendCommand(UClearAllTable);
//SendCommand(USaveAllTable);
//TrasmiteCommand(Serial);

  (*  if MessageDlg('Внимание! Запись параметров в EEPROM!',
     'Выполнить?', mtConfirmation,[mbYes, mbNo],0) = mrNO then exit;
  SendCommand(USaveParam);*)



procedure TForm1.SavetoDiskClick(Sender: TObject);
var ff:file of tbvect;
    i:integer;
    ext:string;
begin
  SD.InitialDir:=StartDir;
  ext:='u'+inttostr(Core.UOZCount);
  SD.Filter:='Файлы таблицы |*.'+ext;
  if SD.Execute then
    begin
      assignfile(ff,SD.FileName);
      rewrite(ff);
      for i:=0 to Core.UOZCount-1 do  write(ff,Core.UOZ[i]);
      closefile(ff);
    end;
  ChangeValue:=true;
end;



procedure TForm1.LoadfromDiskClick(Sender: TObject);
var ff:file of tbvect;
    ext:string;
    tempbool:boolean;
    tempbyte:byte;
    i,j:integer;
begin
OD.InitialDir:=StartDir;
ext:='u'+inttostr(Core.UOZCount);
OD.Filter:='Файлы таблицы |*.'+ext;
if not OD.Execute then exit;
assignfile(ff,OD.FileName);
reset(ff);
for i:=0 to Core.UOZCount-1 do  read(ff,Core.UOZ[i]);
closefile(ff);

GetStarted:=true;
tempbool:=fAutoCtrl.checked; tempbyte:=Core.UOZSelectr;
fAutoCtrl.checked:=false;
SendCommand(USetUARTCtrl);
TrasmiteCommand(Serial);
for j:=0 to Core.UOZCount-1 do
    begin
      SendCommand(USetActiveTable+j);
      for i:=0 to PCount-1 do
                   begin
                     SendCommand(USetAddr+i);
                     SendCommand(USetUOZH+(Core.UOZ[j,i] shr 4));
                     SendCommand(USetUOZL+(Core.UOZ[j,i] and $F));
                   end;
      TrasmiteCommand(Serial);
      while not Core.AllCmdComplite do application.ProcessMessages;
    end;
SendCommand(USetActiveTable+tempbyte);
if tempbool then SendCommand(UClearUARTCtrl)
            else SendCommand(USetUARTCtrl);
fAutoCtrl.checked:=tempbool;
fOUZSelectr.enabled:=tempbool;
TrasmiteCommand(Serial);
GetStarted:=false;
ChangeValue:=true;
RedrawAll;
end;

procedure TForm1.com0AClick(Sender: TObject);
begin
SendCommand(USaveAllTable);
TrasmiteCommand(Serial);
while not Core.AllCmdComplite do application.ProcessMessages;
end;

procedure TForm1.com0CClick(Sender: TObject);
var i:word;
begin
SendCommand(ULoadAllTable);
for i:=0 to Core.UOZCount-1 do SendCommand(UGetTable+i);
TrasmiteCommand(Serial);
for i:=0 to PCount-1 do Core.UOZLoad[i]:=false;
while not LoadAllCore do application.ProcessMessages;
ChangeValue:=true;
RedrawAll;
end;



procedure TForm1.comA0Click(Sender: TObject);
begin
SendCommand(USaveTable+Core.UOZSelectr);
TrasmiteCommand(Serial);
while not Core.AllCmdComplite do application.ProcessMessages;
end;

procedure TForm1.comC0Click(Sender: TObject);
begin
SendCommand(ULoadTable+Core.UOZSelectr);
SendCommand(UGetTable+Core.UOZSelectr);
TrasmiteCommand(Serial);
Core.UOZLoad[Core.UOZSelectr]:=false;
while not LoadAllCore do application.ProcessMessages;
ChangeValue:=true;
RedrawAll;
end;


procedure TForm1.comE0Click(Sender: TObject);
begin
SendCommand(UClearTable+Core.UOZSelectr);
SendCommand(UGetTable+Core.UOZSelectr);
TrasmiteCommand(Serial);
Core.UOZLoad[Core.UOZSelectr]:=false;
while not LoadAllCore do application.ProcessMessages;
ChangeValue:=true;
RedrawAll;
end;

procedure TForm1.com0EClick(Sender: TObject);
var i:integer;
begin
SendCommand(UClearAllTable);
for i:=0 to Core.UOZCount-1 do SendCommand(UGetTable+i);
TrasmiteCommand(Serial);
for i:=0 to PCount-1 do Core.UOZLoad[i]:=false;
while not LoadAllCore do application.ProcessMessages;
ChangeValue:=true;
RedrawAll;
end;

procedure TForm1.FormResize(Sender: TObject);
var minwidth:integer;
begin
 minwidth:=Panel.Width+fOUZControl.Width+fN0.Width+fOUZ.Width;
 if form1.Width<minwidth+10 then form1.Width:=minwidth+10;
 ChangeValue:=true;
 RedrawAll;
end;

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  SendCommand(UClearUARTCtrl);
  TrasmiteCommand(Serial);
  SaveOUZ('exitsave.u'+inttostr(Core.UOZCount));
end;

procedure TForm1.serialRxData(Sender: TObject);
var a:string;
    i:integer;
begin
  a:=Serial.ReadData;
  for i:=1 to length(a) do
      begin
        if RbuffptrO=IncPtr(RbuffptrI) then exit; //буфер переполнен
        RbuffptrI:=IncPtr(RbuffptrI);
        RBuff[RbuffptrI]:=ord(a[i]);
      end;
end;

Procedure AutoSaveOUZ;
begin
  if not AutoSave.Delay then exit;
  SaveOUZ('autosave.u'+inttostr(Core.UOZCount));
  AutoSave.Cnt:=SystemCnt+AutoSaveTime;
end;

procedure TForm1.timerTimer(Sender: TObject);
begin
  inc(SystemCnt);   // Таймер ожидания;
  if WDT.Delay and (SystemCnt>WDT.Cnt) then WDT.Delay:=false;
  if SystemCnt>AutoSave.Cnt then AutoSaveOUZ;
  DoAction;
  repeat
  until not GetData;
end;

Function GetData:boolean;
var temp,i:word;
    CMD,CML,CmdLength:byte;
    ukj,NextCMD:word;
begin
  GetData:=false;
  if subPtr(RbuffptrI,RbuffptrO)<10 then exit;  //мало данных
  if subPtr(RbuffptrI,RbuffptrO)<RBuff[addPtr(RbuffptrO,2)]+2 then exit;  //мало данных
  GetData:=true;
//есть как мимнимум одна полная команда
  ukj:=incPtr(RbuffptrO);
  CMD:=RBuff[ukj];
  ukj:=incPtr(ukj);
  CmdLength:=RBuff[ukj];
  NextCMD:=addPtr(RbuffptrO,2+CmdLength);
  if (CMD and $E0=UGetTable) and (Core.LoadConst) then
     begin
       CML:=(CMD and $1F) and (Core.UOZCount-1);
       Core.UOZLoad[CML]:=true;
       with Core do
              for i:=0 to PCount-1 do
                     begin
                       ukj:=incPtr(ukj); UOZ[CML,i]:=Rbuff[ukj];
                       UOF[CML,i]:=OUZFP8toAlfa(Rbuff[ukj]);
                       if UOF[CML,i]<0 then UOF[CML,i]:=0;
                     end;
     end;
  if (CMD=UGetActiveTable) and (Core.LoadParam) then
         with Core do
            begin
              UOZLoad[UOZSelectr]:=true;
              for i:=0 to PCount-1 do
                     begin
                       ukj:=incPtr(ukj); UOZ[UOZSelectr,i]:=Rbuff[ukj];
                       UOF[UOZSelectr,i]:=OUZFP8toAlfa(Rbuff[ukj]);
                       if UOF[UOZSelectr,i]<0 then UOF[UOZSelectr,i]:=0;
                     end;
            end;
  if (CMD=UGetParam) and (Core.LoadConst) then
       with Core do
            begin
              NCCOld:=NCC;
              UOZCurrentFP16Old:=UOZCurrentFP16;
              UOZSelectrOld:=UOZSelectr;
              UOZOld:=UOZ;
              ukj:=incPtr(ukj); NCC:=Rbuff[ukj] shl 8;
              ukj:=incPtr(ukj); NCC:=NCC+Rbuff[ukj];
              ukj:=incPtr(ukj); Selectr:=Rbuff[ukj];
              ukj:=incPtr(ukj); UOZSelectr:=Rbuff[ukj] and (UOZCount-1);
              ukj:=incPtr(ukj); Status:=Rbuff[ukj];
              if (Status and $1)>0 then UARTCtrl:=true else UARTCtrl:=false;
              ukj:=incPtr(ukj); EStatus:=Rbuff[ukj];
              AllCmdComplite:=true;
              if EStatus and $40>1 then AllCmdComplite:=false;
              ukj:=incPtr(ukj); UOZCurrentFP16:=Rbuff[ukj] shl 8;
              ukj:=incPtr(ukj); UOZCurrentFP16:=UOZCurrentFP16+Rbuff[ukj];
              Alfa:=OUZFP16toAlfa(UOZCurrentFP16);
              ukj:=incPtr(ukj); TableAdress:=Rbuff[ukj];
              if Status and $80>0 then LowMode:=true else LowMode:=false;
              if Status and $40>0 then StopMode:=true else StopMode:=false;
              if Status and $20>0 then OUZMax:=true else OUZMax:=false;
              if Status and $10>0 then OUZMin:=true else OUZMin:=false;
              if LowMode then No:=0
                         else No:=round(AF/NCC);
              LoadParam:=true;
            end;
  if CMD=UGetTester then
       with Core do
            begin
              form1.label3.visible:=true;
              form1.label2.visible:=true;
              form1.label3.caption:='';
              ukj:=incPtr(ukj); tester[0]:=Rbuff[ukj];
              form1.label3.caption:=form1.label3.caption+inttohex(Rbuff[ukj],2)+' ';
              ukj:=incPtr(ukj); tester[1]:=Rbuff[ukj];
              form1.label3.caption:=form1.label3.caption+inttohex(Rbuff[ukj],2)+' ';
              ukj:=incPtr(ukj); tester[2]:=Rbuff[ukj];
              form1.label3.caption:=form1.label3.caption+inttohex(Rbuff[ukj],2)+' ';
              ukj:=incPtr(ukj); tester[3]:=Rbuff[ukj];
              form1.label3.caption:=form1.label3.caption+inttohex(Rbuff[ukj],2)+' ';
              ukj:=incPtr(ukj); tester[4]:=Rbuff[ukj];
              form1.label3.caption:=form1.label3.caption+inttohex(Rbuff[ukj],2)+' ';
              ukj:=incPtr(ukj); tester[5]:=Rbuff[ukj];
              form1.label3.caption:=form1.label3.caption+inttohex(Rbuff[ukj],2)+' ';
              ukj:=incPtr(ukj); tester[6]:=Rbuff[ukj];
              form1.label3.caption:=form1.label3.caption+inttohex(Rbuff[ukj],2)+' ';
              ukj:=incPtr(ukj); tester[7]:=Rbuff[ukj];
              form1.label3.caption:=form1.label3.caption+inttohex(Rbuff[ukj],2)+' ';
              LDELTALength:=tester[6] shl 8+tester[7];
              if LDELTALength>0 then LDELTALength:=LDELTALength/(LDELTALength+tester[4] shl 8+tester[5])*Base;
              form1.label2.caption:='Длина метки '+floattostrf(LDELTALength,ffFixed,4,1)+' град.'
            end;
  if CMD=UGetConst then
       with Core do
            begin
              ukj:=incPtr(ukj); Version:=Rbuff[ukj];
              ukj:=incPtr(ukj); OUZMinFP8:=Rbuff[ukj];
              ukj:=incPtr(ukj); OUZMaxFP8:=Rbuff[ukj];
              ukj:=incPtr(ukj); LDelta:=Rbuff[ukj];
              ukj:=incPtr(ukj); Base:=Rbuff[ukj] shl 8;
              ukj:=incPtr(ukj); Base:=Base+Rbuff[ukj];
              ukj:=incPtr(ukj); Fn:=Rbuff[ukj];
              ukj:=incPtr(ukj); Ka:=Rbuff[ukj];
              ukj:=incPtr(ukj); UOZCount:=Rbuff[ukj];
              form1.fOUZSelectr.Max:=UOZCount-1;
              form1.fOUZSelectr.SelEnd:=UOZCount-1;
              AF:=4000000/3*(Base-LDelta)/(1+Fn);
              GFP8:=(Base-LDelta)/(128*Ka);
              GFP16:=(Base-LDelta)/(32768*Ka);
              AlfaMax:=OUZFP8toAlfa(OUZMinFP8);
              if CmdLength=11 then               //Для совместимости со старой версии, где нет дробной части
                begin
                  ukj:=incPtr(ukj); LDeltaFP16:=Rbuff[ukj] shl 8;
                  ukj:=incPtr(ukj); LDeltaFP16:=LDeltaFP16+Rbuff[ukj];
                  LDelta:=LDelta+LDeltaFP16/32768;
                end;
              LoadConst:=true;
            end;
if CMD=UGetIndex then
    with Core do
          begin
              for i:=0 to PCount-1 do
                   begin
                     ukj:=incPtr(ukj); Index[i]:=Rbuff[ukj];
                     ukj:=incPtr(ukj); Index[i]:=Index[i]+Rbuff[ukj] shl 8;
                     NC[i]:=trunc(AF/Index[i]);
                   end;
              Nmax:=NC[0]+NC[0] div 25;
              Nmin:=round(NC[PCount-1]*0.9);
              LoadIndex:=true;
          end;
RbuffptrO:=NextCMD;
end;



procedure DoAction;

begin
if not Core.LoadParam then exit;
with  form1 do
 begin
   fOUZControl.Caption:='Активная страница '+inttostr(Core.UOZSelectr+1)+' из '+inttostr(Core.UOZCount);
   if Core.LowMode  then fLowMode.brush.color:=clYellow
                    else fLowMode.brush.color:=clWhite;
   if Core.StopMode then fStopMode.brush.color:=clRed
                    else fStopMode.brush.color:=clWhite;
   if Core.OUZMax   then fOUZMax.brush.color:=clYellow
                    else fOUZMax.brush.color:=clWhite;
   if Core.OUZMin   then fOUZMin.brush.color:=clYellow
                    else fOUZMin.brush.color:=clWhite;
   com0A.enabled:=Core.LowMode;
   comA0.enabled:=Core.LowMode;
   lb_No.caption:=inttostr(Core.No)+' ';
   lb_No.font.color:=clBlack;
   lb_alfa.caption:=floattostrf(Core.Alfa,ffFixed,6,2)+' ';
   if (not Core.UARTCtrl) and (fOUZSelectr.Position<>Core.UOZSelectr) then
                            begin
                              GetStarted:=true;
                              fOUZSelectr.Position:=Core.UOZSelectr;
                              GetStarted:=false;
                            end;
   fOUZSelectr.enabled:=Core.UARTCtrl;
   if ChangeCore then ChangeValue:=true;
   RedrawAll;
   SendCommand(UGetParam);
   if ShowTester then SendCommand(UGetTester);    // Показывать  тестовый массив tester
   TrasmiteCommand(Serial);
 end;
end;

procedure TForm1.fAutoCtrlChange(Sender: TObject);
begin
  if GetStarted then exit;
  if fAutoCtrl.checked then SendCommand(UClearUARTCtrl)
                       else SendCommand(USetUARTCtrl);
  TrasmiteCommand(Serial);
end;

procedure TForm1.fOUZSelectrChange(Sender: TObject);
begin
  if GetStarted then exit;
  Core.LoadParam:=false;
  SendCommand(USetActiveTable+fOUZSelectr.Position);
  SendCommand(UGetParam);
  TrasmiteCommand(Serial);
  while not Core.LoadParam do application.ProcessMessages;
  ChangeValue:=true;
end;


Begin
  getdir(0,StartDir);
  StartDir:=CP1251ToUTF8(StartDir);
  UOZptr:=0;
  MovePoint:=false;

end.

